Bug 344281 - wine does not use pulseaudio
wine does not use pulseaudio
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: wine (Show other bugs)
8
All Linux
low Severity low
: ---
: ---
Assigned To: Andreas Bierfert
Fedora Extras Quality Assurance
: Reopened
Depends On: 426882
Blocks: 415331
  Show dependency treegraph
 
Reported: 2007-10-21 05:47 EDT by Martin Jürgens
Modified: 2009-02-24 15:40 EST (History)
1 user (show)

See Also:
Fixed In Version: 1.0-1.fc9
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-09 02:55:15 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Martin Jürgens 2007-10-21 05:47:42 EDT
Description of problem:
wine does not use pulseaudio when selecting "ALSA" as output plugin.
Comment 1 Martin Jürgens 2007-11-09 13:09:43 EST
Correction, seems that Wine does not support PulseAudio output. Any chance to
listen to music and to run wine applications?

I tried ESD, which works - but with a high latency (like 4 seconds).
Comment 2 Andreas Bierfert 2007-11-09 17:12:38 EST
Well it worked for me 'the old way' perfectly well and I am not aware of any
pulse support in wine that could be enabled. I myself have not looked at pulse
audio stuff in detail yet. Will investigate.
Comment 3 Martin Jürgens 2007-11-09 17:33:45 EST
Yeah, I am not aware of PA support in Wine, also. Just saw a ML thread about
developing a PA driver.

Do you mean that PA + Wine work using OSS by saying "the old way"? I already
tried that, but it may be caused by me having upgraded my installation. May be
that some compatibility stuff was not installed when doing the update.
Comment 4 Andreas Bierfert 2007-11-09 17:42:26 EST
I mean as in pre F8 +) I will do some pa f8 testing tomorrow when I get time.
Comment 5 Martin Jürgens 2007-11-09 17:50:55 EST
Worked fine in pre F8 for me, also :) Would be nice if you could do some testing :-)
Comment 6 Martin Jürgens 2007-11-12 07:10:56 EST
I investigated a little bit. The best way to use Wine and PA seems to be the
following to me:

replace /usr/bin/wine with a simple shell script which checks for the existance
of /usr/bin/padsp. If /usr/bin/padsp exits, that shell script calls 

/usr/bin/padsp /usr/bin/wine_binary PROGRAM.EXE / COMMANDS

If not, it calls /usr/bin/wine_binary PROGRAM.EXE / COMMANDS

the Audio output has to be set to OSS in winecfg. This would be a sane solution
to me up to the point Wine releases a PA audio backend.
Comment 7 Martin Jürgens 2007-11-15 12:01:44 EST
I did some more investigation.

Basically, the script wine should look like this:


#!/bin/sh
if test -x /usr/bin/padsp ; then
exec padsp -- /usr/bin/wine_binary "$@"
else 
exec /usr/bin/wine_binary "$@"
fi
Comment 8 Martin Jürgens 2007-11-15 12:03:31 EST
        -n <name>           client name to report to the server
        -m <name>           stream name to report to the server

may be nice as parameters, also.
Comment 9 Andreas Bierfert 2007-11-26 02:36:39 EST
Hm thanks for your work on this. I do not feel quiet fine with supplying this as
direct replacement for the wine call as it may bring some undesired side
effects. However I guess I will be adding it to .50 as a wine-pulseaudio script
and add a README-FEDORA-PULSEAUDIO.
Comment 10 Joe Hardesty 2007-12-28 08:53:52 EST
Just to make sure you're aware, this fix does not work with all programs (it
does not work with Steam games, I found some discussion about it here:
http://www.nabble.com/-Bug-10902--New:-Steam-and-PulseAudio-td14508290.html)

So far the only consistent fix I have found is to use ESD, lowering the hardware
acceleration setting in wine helped with sound latency somewhat though it still
has a delay and bad static.
Comment 11 Fedora Update System 2007-12-28 12:12:52 EST
wine-0.9.51-2.fc8 has been pushed to the Fedora 8 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update wine'
Comment 12 Joe Hardesty 2007-12-28 20:31:31 EST
I've confirmed audio in Steam games isn't working on my system with
wine-0.9.51-2.fc8.  With oss selected, game loading stalls and dies - no errors
on the console, the loading window simply stops redrawing after a while.  ESD
still works, with latency.

On an unrelated plus side, this release appears to work with my nVidia 8800gt,
it's the first package since 0.9.46 in FC7 with working 3D graphics for me.
Comment 13 Andreas Bierfert 2007-12-28 20:42:29 EST
Well I am afraid that there is nothing much a can do about this for people using
pulseaudio atm besides what has been done now.
Comment 14 Henry Kroll 2007-12-28 20:58:13 EST
Wine alsa audio has been working fine for me in F8 using pulseaudio -D and
setting winecfg to alsa with emulation (3 machines with different soundcards,
VIA, Creative & ATI). Starcraft and EverQuest2 were tested.
Comment 15 Henry Kroll 2007-12-28 20:59:55 EST
Wine version 0.9.51 custom built RPM by me.
Comment 16 Andreas Bierfert 2007-12-28 21:10:44 EST
I will give .52 and pulseaudio a testing round tomorrow and see what I get as
best results and go from there.
Comment 17 Henry Kroll 2007-12-28 21:30:38 EST
Nevermind... wine "works" in that I hear sound but it is not using pulseaudio,
according to paman. Erase erase.
Comment 18 Joe Hardesty 2007-12-29 00:27:36 EST
Sorry if it seemed I was putting down the OSS change, it is definitely better
than no sound at all!  I just thought the drawback should be documented.  It
looks as though the problem is due to the way some programs interact with the
OSS plugin, not due to the plugin itself or the padsp workaround.  Though I
would be glad to be proven wrong...

Henry, are there any specific changes you made to the default install to make
alsa work around pulseaudio?  Or am I misunderstanding? 
Comment 19 Henry Kroll 2007-12-29 11:56:26 EST
I have a custom gstreamer-plugins-pulse-0.9.7-0.7.svn20071209.fc8.i386 which is
letting me hear sound from apps that are not yet compatible with pulseaudio.
They just don't show up as clients in paman.

If I play a sound using alsa with any program other than wine, such as aplay,
xmms, firefox/flashplayer9, it shows up in paman as a client. Example:

aplay /usr/share/system-config-soundcard/sound-sample.wav #yes paman client

wine programs, on the other hand, do not show up as clients. Audacity is another
example of an alsa program that does not show up as a client. There was some
talk on the pulseaudio perfect setup page about audacity as well as other alsa
programs that are not yet compatible with pulseaudio's pulse alsa plugin and
patches for them http://www.pulseaudio.org/wiki/PerfectSetup#ThirdPartyApplications
perhaps a patch for wine could be made using this info.
Comment 20 Henry Kroll 2007-12-29 12:04:39 EST
The svn version of gstreamer-plugins-pulse was necessary for me to get rid of
the 3 second delay in audio using ESD. The audio delay was evidently caused by a
timeout when programs like wine and mplayer that try to access the hardware
directly. Pulseaudio does not allow that so there is an error generated and the
application then tries again without hardware acceleration or fails. Wine esd
was going through, with delays, while wine alsa was failing (no sound). With the
svn version of gstreamer-plugins-pulse, wine at least has sound, but it is going
around (bypassing) pulseaudio. I hope I have explained what I think I have
learned about this. I am still not sure exactly how it works. :)
Comment 21 Fedora Update System 2008-01-02 20:40:56 EST
wine-docs-0.9.52-1.fc8, wine-0.9.52-2.fc8 has been pushed to the Fedora 8 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update wine-docs wine'
Comment 22 Joe Hardesty 2008-01-05 22:50:51 EST
Sorry that this isn't directly related.. I haven't had the chance to test sound
with 0.9.52, but it does bring back some of the video issues I was having.  I
neglected to back up the testing 0.9.51 release and I can't find it in any of
the repositories, is there any place where the older RPMs could be found?
Comment 24 Fedora Update System 2008-01-06 20:26:53 EST
wine-docs-0.9.52-1.fc8, wine-0.9.52-2.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 25 john bradley 2008-01-24 08:23:17 EST
i just installed wine-0.9.52-2.fc8. i also installed pulseaudio's alsa plugins
package. i am getting the following errors when trying to use alsa in winecfg. 

Running padsp as pulseaudio wrapper for wine
ALSA lib conf.c:3949:(snd_config_expand) Unknown parameters 0
ALSA lib pcm.c:2145:(snd_pcm_open_noupdate) Unknown PCM default:0
ALSA lib conf.c:3949:(snd_config_expand) Unknown parameters 0
ALSA lib pcm.c:2145:(snd_pcm_open_noupdate) Unknown PCM default:0

however, if i enable esd, sound works. This seems to defeat the purpose of using
pulseaudio though. does 'add fix for #344281 pulseaudio workaround' only apply
to oss or am i missing something here? all relevant wine and pulseaudio pacakges
are up to date and i'm running kernel 2.6.23.9-85.fc8. is gstreamer through
subversion our only workaround for alsa/pulseaudio?
Comment 26 Martin Jürgens 2008-06-17 08:14:40 EDT
Andreas, the following one-line patches:

http://www.winehq.org/pipermail/wine-patches/2008-June/055701.html

http://www.winehq.org/pipermail/wine-patches/2008-June/055708.html

fix Wine's alsa backend to work together with PulseAudio, even with DirectSound.

You just have to select the Alsa output backend and are ready to go. I have
spoken to the Wine release manager, and he told me that he wouldn't include them
into 1.0 but into 1.0.1 instead probably.

Maybe those should be included in the Fedora RPMs, as it uses PA by default.
Comment 27 Fedora Update System 2008-06-17 15:37:06 EDT
wine-docs-1.0-1.fc9 has been submitted as an update for Fedora 9
Comment 28 Fedora Update System 2008-06-17 15:41:15 EDT
wine-docs-1.0-1.fc8 has been submitted as an update for Fedora 8
Comment 29 Fedora Update System 2008-06-17 15:42:00 EDT
wine-docs-1.0-1.fc7 has been submitted as an update for Fedora 7
Comment 30 Martin Jürgens 2008-06-17 15:58:01 EDT
Thanks for including it, works fine.
Comment 31 Fedora Update System 2008-06-26 04:31:12 EDT
wine-1.0-1.fc9, wine-docs-1.0-1.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 32 Fedora Update System 2008-06-26 04:34:39 EDT
wine-1.0-1.fc8, wine-docs-1.0-1.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 33 Martin Jürgens 2008-08-23 07:36:33 EDT
I noticed that Wine 1.1.3 ships with this in its changelog:


  - Tweaks for better PulseAudio support.


So it may be worth trying if the patches are actually needed anymore in order to make Wine work with Pulseaudio. Thanks!
Comment 34 Bug Zapper 2008-11-26 03:02:50 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 35 Luo Bin 2008-12-03 12:02:25 EST
This problem seems still exist in Fedora 10.
After play the test audio in winecfg,the program turned frozen and lost reponse.
Version:  wine 1.1.9
System:  Fedora 10
some useful patches (maybe): http://bugs.winehq.org/show_bug.cgi?id=10495
Comment 36 Fedora Update System 2008-12-10 01:27:23 EST
wine-1.1.10-1.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/wine-1.1.10-1.fc10
Comment 37 Fedora Update System 2008-12-10 01:28:11 EST
wine-1.1.10-1.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/wine-1.1.10-1.fc9
Comment 38 Fedora Update System 2008-12-10 01:28:47 EST
wine-1.1.10-1.fc8 has been submitted as an update for Fedora 8.
http://admin.fedoraproject.org/updates/wine-1.1.10-1.fc8
Comment 39 Fedora Update System 2008-12-11 02:59:08 EST
wine-1.1.10-1.fc9 has been pushed to the Fedora 9 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing-newkey update wine'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F9/FEDORA-2008-11147
Comment 40 Fedora Update System 2008-12-11 03:00:02 EST
wine-1.1.10-1.fc8 has been pushed to the Fedora 8 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing-newkey update wine'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F8/FEDORA-2008-11152
Comment 41 Fedora Update System 2008-12-11 03:00:17 EST
wine-1.1.10-1.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update wine'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2008-11153
Comment 42 Fedora Update System 2009-01-08 13:38:02 EST
wine-1.1.12-1.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/wine-1.1.12-1.fc9
Comment 43 Fedora Update System 2009-01-08 13:39:07 EST
wine-1.1.12-1.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/wine-1.1.12-1.fc10
Comment 44 Bug Zapper 2009-01-09 02:55:15 EST
Fedora 8 changed to end-of-life (EOL) status on 2009-01-07. Fedora 8 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 45 Fedora Update System 2009-01-14 22:09:00 EST
wine-1.1.12-1.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 46 Fedora Update System 2009-02-24 15:40:51 EST
wine-1.1.14-1.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.